(function()
{
    if(!window.__webview__)
    {
        window.__webview__ = {};
    }
    var context = window.__webview__;
    var native = window.__native__;

    /** 改变返回 **/
    if(!context.historyGo)
    {
        context.historyGo = window.history.go;
        window.history.back = function()
        {
            native.back();
        };
        window.history.go = function(numberOrUrl)
        {
            if(!isNaN(numberOrUrl))
            {
                if(numberOrUrl < 0)
                {
                    native.back();
                    return;
                }
            }
            context.historyGo(numberOrUrl);
        };
    }

    /** 全局长按 **/
    document.body.ontouchstart = function(e)
    {
        context.touchDom = {};
        var dom = e.target;

        /*过滤表单控件*/
        var tagName = dom.tagName.toLowerCase();
        if(tagName === "input" || tagName === "textarea" || tagName === "select")
        {
            return;
        }

        /* 图片src */
        var imgDom = dom;
        if(imgDom.tagName.toLowerCase() === "img")
        {
            if(imgDom.src && imgDom.src.indexOf("data:") !== 0)
            {
                context.touchDom.imgSrc = imgDom.src;
            }
        }

        /* 超连接href */
        var aDom = dom;
        while(true)
        {
            if(aDom.tagName.toLowerCase() === "body")
            {
                break;
            }
            if(aDom.tagName.toLowerCase() === "a")
            {
                if(aDom.href && aDom.href.indexOf("javascript:") !== 0)
                {
                    context.touchDom.aHref = aDom.href;
                    break;
                }
            }
            aDom = aDom.parentNode;
        }

        /* 元素定位selector */
        var selectorDom = dom;
        var selector = "";
        while(true)
        {
            if(selectorDom.tagName.toLowerCase() === "body")
            {
                selector = "body>" + selector;
                break;
            }

            if(selectorDom.id)
            {
                selector = "#" + selectorDom.id + ">" + selector;
                selectorDom = selectorDom.parentNode;
                continue;
            }

            /* 读取元素在父元素的下标 */
            var index = 1;
            for(var i = 0; i < selectorDom.parentNode.children.length; i++)
            {
                if(selectorDom === selectorDom.parentNode.children[i])
                {
                    index = i + 1;
                    break;
                }
            }

            var selectorDomClass = selectorDom.getAttribute("class");
            if(selectorDomClass)
            {
                var tmp = selectorDomClass.trim().split(" ");
                var className = "";
                for(var i = 0; i < tmp.length; i++)
                {
                    if(tmp[i].trim() !== "")
                    {
                        className += "." + tmp[i];
                    }
                }
                selector = className + ":nth-child(" + index + ")>" + selector;
                selectorDom = selectorDom.parentNode;
                continue;
            }

            selector = selectorDom.tagName.toLowerCase() + ":nth-child(" + index + ")>" + selector;
            selectorDom = selectorDom.parentNode;
        }
        context.touchDom.selector = selector.substring(0, selector.length - 1);
    };
    context.getTouchDom = function()
    {
        return context.touchDom;
    };

    /** 媒体资源抓取 **/
    context.selectMedias = function()
    {
        console.log("媒体解析: 开始");
        var callback = function(videoList)
        {
            var videoArray = new Array();
            var imageArray = new Array();
            var audioArray = new Array();

            for(var i = 0; i < videoList.length; i++)
            {
                var video = videoList[i];
                videoArray.push({
                    url: video.url,
                    quality: video.quality,
                    preciseVideo: true
                });
            }

            var getDocuments = function(container, doc)
            {
                container.push(doc);

                /* 递归读取所有docuemnt */
                var iframes = doc.querySelectorAll("iframe");
                for(var i = 0; i < iframes.length; i++)
                {
                    var iframe = iframes[i];
                    console.log("媒体解析: 解析文档" + iframe.getAttribute("src"));
                    try
                    {
                        if(iframe.contentWindow.document)
                        {
                            getDocuments(container, iframe.contentWindow.document);
                        }
                    }
                    catch(e)
                    {
                        console.log("媒体解析: 读取文档" + iframe.getAttribute("src") + "错误" + e);
                    }
                }
            };

            var documents = [];
            console.log("媒体解析: 开始解析document");
            getDocuments(documents, document);
            console.log("媒体解析: document数量" + documents.length);

            for(var k = 0; k < documents.length; k++)
            {
                var doc = documents[k];

                var videos = doc.querySelectorAll("video");
                for(var i = 0; i < videos.length; i++)
                {
                    var video = videos[i];
                    console.log("媒体解析: 解析到video标签:" + video);

                    if(video.src && video.src.indexOf("http") === 0)
                    {
                        videoArray.push({
                            url: video.src
                        });
                    }

                    var sources = video.querySelectorAll("source");
                    for(var j = 0; j < sources.length; j++)
                    {
                        var source = sources[j];
                        if(source.src && source.src.indexOf("http") === 0)
                        {
                            videoArray.push({
                                url: source.src
                            });
                        }
                    }
                }

                var imgs = doc.querySelectorAll("img");
                for(var i = 0; i < imgs.length; i++)
                {
                    var img = imgs[i];
                    if(img.src && img.src.indexOf("http") === 0)
                    {
                        imageArray.push({
                            url: img.src
                        });
                    }
                }

                var audios = doc.querySelectorAll("audio");
                for(var i = 0; i < audios.length; i++)
                {
                    var audio = audios[i];
                    if(audio.src && audio.src.indexOf("http") === 0)
                    {
                        audioArray.push({
                            url: audio.src
                        });
                    }

                    var sources = audio.querySelectorAll("source");
                    for(var j = 0; j < sources.length; j++)
                    {
                        var source = sources[j];
                        if(source.src && source.src.indexOf("http") === 0)
                        {
                            audioArray.push({
                                url: source.src
                            });
                        }
                    }
                }
            }

            var data = {
                videoArray: videoArray,
                imageArray: imageArray,
                audioArray: audioArray
            };
            native.onMediaExtract(JSON.stringify(data));
        };

        if(window.extractor)
        {
            window.extractor.extract(callback);
        }
        else
        {
            callback([]);
        }
    };

    /** 强制自动填充 **/
    context.autofill = function(usernameValue, passwordValue)
    {
        var username = document.querySelector("input[id=username]");
        if(!username)
        {
            username = document.querySelector("input[name=username]");
        }
        if(!username)
        {
            username = document.querySelector("input");
        }
        var password = document.querySelector("input[type=password]");

        if(password)
        {
            if(username)
            {
                username.value = usernameValue;
            }

            if(password)
            {
                password.value = passwordValue;
                password.focus();
            }
        }
    };

    /** 高亮元素 **/
    context.inspectElements = function(selector)
    {
        var inspectElements = document.querySelectorAll(".__webview_element_inspect__");
        if(inspectElements)
        {
            for(var i = 0; i < inspectElements.length; i++)
            {
                var element = inspectElements[i];
                element.parentNode.removeChild(element);
            }
        }

        if(selector)
        {
            var elements = document.querySelectorAll(selector);
            for(var i = 0; i < elements.length; i++)
            {
                var element = elements[i];

                var div = document.createElement("div");
                div.setAttribute("class", "__webview_element_inspect__");
                div.style.position = "absolute";
                div.style.backgroundColor = "#00a0f0";
                div.style.opacity = 0.8;
                div.style.zIndex = 2147483647;
                div.style.left = "0px";
                div.style.top = "0px";
                div.style.right = "0px";
                div.style.bottom = "0px";
                div.style.width = "100%";
                div.style.height = "100%";
                div.style.display = "block";

                var position = window.getComputedStyle(element, null)["position"];
                if(position !== "absolute" && position !== "fixed" && position !== "relative")
                {
                    element.style.position = "relative";
                }
                element.appendChild(div);
            }
        }
    };

    /** 删除元素 **/
    context.deleteElements = function(selector)
    {
        var elements = document.querySelectorAll(selector);
        if(elements)
        {
            for(var i = 0; i < elements.length; i++)
            {
                var element = elements[i];
                element.parentNode.removeChild(element);
            }
        }
    };
})();